#! /bin/sh                                                                                                             
#remember: cant have spaces between equals signs in assignments
#options(1): 1 letter identifier for experimets eg 1A

WALLTIME=6

GAMMA[1]=2.0
SIGMA[1]=2.5
EPSI[1]=0.4
CVPSI[1]=0.6
CVZETA[1]=0.0
BLIMGUESS[1]=-0.15

GAMMA[2]=4.0
SIGMA[2]=4.0
EPSI[2]=0.4
CVPSI[2]=0.5
CVZETA[2]=0.0
BLIMGUESS[2]=-0.05


GAMMA[3]=1.2
SIGMA[3]=1.5
EPSI[3]=0.4
CVPSI[3]=0.01
CVZETA[3]=0.0
BLIMGUESS[3]=-2.0


GAMMA[4]=2.5
SIGMA[4]=4.0
EPSI[4]=0.4
CVPSI[4]=1.0
CVZETA[4]=0.0
BLIMGUESS[4]=-0.5


#since it is only input variables that are changing, we can compile once and for all here
./CompileOnly.sh mainprog$1

for g in 1 2 3 4; do
	for type in Year Cohort; do
		
		#create name for job
		JOBNAME=$1$type"g"$g

		#create directory for job
		cd Results
		if [ ! -d "$JOBNAME" ]; then
			mkdir $JOBNAME
		fi
		cd ..
		
		#create input file
		cd Input
		INPUTFILE="input_"$JOBNAME".txt"
        if [ -f "$INPUTFILE" ]; then
                rm $INPUTFILE
        fi
        echo -e  "\"Results/$JOBNAME/\"\n\"Input/Single/$type/\"\n\"Input/$type"AgeEffectsOrder4"/\"\n${GAMMA[$g]}\n${SIGMA[$g]}\n${EPSI[$g]}\n${CVPSI[$g]}\n${CVZETA[$g]}\n${BLIMGUESS[$g]}" >> $INPUTFILE
        cd ..
	
		#make pbs file
		if [ -f "Submit_$JOBNAME.pbs" ]; then
			rm Submit_$JOBNAME.pbs
		fi
	
		echo -e "#! /bin/sh \n#PBS -l nodes=1:ppn=8,walltime=$WALLTIME:00:00 \n#PBS -N $JOBNAME \n#PBS -M gwk210@nyu.edu \n#PBS -m abe \n#PBS -j oe \ncd $PWD \n./mainprog$1.out $INPUTFILE > Results/$JOBNAME/output.txt" >> Submit_$JOBNAME.pbs
		
		#submit
		#qsub Submit_$JOBNAME.pbs
	done
done