!!!!!!!!!!!!!!!!!!!!!!
!DrawRandomNumbers!!!!
!!!!!!!!!!!!!!!!!!!!!!
!Draw realizations of uniform random variables for each of #nsim simulations.
!Created 11/22/09 - ERS

SUBROUTINE DrawRandomNumbers

USE Parameters
USE Globals
USE random

IMPLICIT NONE

INTEGER	   :: iseed(2),isize,in

!set random number seed
isize = 2
iseed(1) = 7755
iseed(2) = 7744
CALL RANDOM_SEED(size = isize)
CALL RANDOM_SEED(put = iseed)

!Draws for preference heterogeneity
CALL RANDOM_NUMBER(fPrand)
CALL RANDOM_NUMBER(fTrand)

!Draws for fixed effect
CALL RANDOM_NUMBER(arand)

!Draws for transitory and persistent shocks (wages)
CALL RANDOM_NUMBER(zrand)
CALL RANDOM_NUMBER(erand)

!Draws for initial assets
CALL RANDOM_NUMBER(krand1)

DO in = 1,nsim
	krand2(in) = random_normal()
END DO

!Draws for hours constraint
CALL RANDOM_NUMBER(hrand)

END SUBROUTINE DrawRandomNumbers