REAL(8) FUNCTION FnAggHours(lx)

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

REAL(8), INTENT(IN) :: lx
REAL(8)             :: lavhours


!Might want to change this specification for Hours versus Leisure?
if(LeisUtilPower==1 .or. HourUtilPower==1) then

	Epsipow = exp(lx)
	Vpsipow = (Epsipow*CVpsipow)**2.0
	Vlogpsipow = log(Vpsipow/(Epsipow**2.0) +1.0)
	Elogpsipow = log(Epsipow) - Vlogpsipow/2.0
	Elogpsi = (1.0-gam)*Elogpsipow - (gam+sig)*log(targethours)
	Epsi = exp((1.0-gam)*Elogpsipow +((1.0-gam)**2.0)*Vlogpsipow/2.0) / (targethours**(sig+gam))
	Vlogpsi = ((1.0-gam)**2.0)*Vlogpsipow

	if (Epsi<0.0) then
		FnAggHours = 1.0-targethours
		write(*,*) '  Mean psi, psipow guess: ',Epsi,Epsipow
		write(*,*) '  Average Hours: ', 1.0
		return
     end if
	

else if(LeisUtilExpon==1 .or. HourUtilExpon==1) then
	!this bit not correct
    Elogpsi = lx
    Epsi = dexp(Elogpsi+Vlogpsi/2.0)
end if



if(Display>=1 .and. LeisUtilPower==1) write(*,*) '  Mean psi guess: ',Epsi
if(Display>=1 .and. LeisUtilExpon==1) write(*,*) '  Mean log psi guess: ',Elogpsi
if(Display>=1 .and. HourUtilPower==1) write(*,*) '  Mean psipow guess: ',Epsipow
if(Display>=1 .and. HourUtilExpon==1) write(*,*) '  Mean log psi guess: ',Elogpsi

CALL Grids
CALL Decisions
CALL Simulate

lavhours = SUM(SUM(htotsim(:,1:Twork), DIM=1)*popsize(1:Twork)) / SUM(nsim*popsize(1:Twork))

FnAggHours = lavhours-targethours
if (Display>=1) write(*,*) '  Average Hours: ', lavhours

END FUNCTION FnAggHours
