REAL(8) FUNCTION FnBetaKY(lbet)

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

REAL(8), INTENT(IN) :: lbet
REAL(8)             :: lcapital,lincome,lcapitalwork,whichperc(2),lperc(2),llogEpsi
INTEGER				:: iflag
REAL(8), EXTERNAL	:: FnAggHours

bet = lbet
if(Display>=1) write(*,*) ' Beta guess: ',bet
IF (MatchAggHours==0) THEN

    CALL Decisions
    CALL Simulate
        
ELSE
    IF(LeisUtilPower==1) CALL rtsecAggHours(log(Epsi),log(Epsi*0.8),0.001_8,iflag)
    IF(HourUtilPower==1) CALL rtsecAggHours(log(Epsipow),log(Epsipow*0.75),0.001_8,iflag)	
    IF(LeisUtilExpon==1 .or. HourUtilExpon==1) CALL rtsecAggHours(Elogpsi,Elogpsi*0.8,0.005_8,iflag)
	IF(iflag>0) THEN
	    IF(LeisUtilPower==1) CALL rtbis(FnAggHours,log(0.001_8),log(1.0e10_8),0.001_8,0.01_8,llogEpsi)
	    IF(HourUtilPower==1) CALL rtbis(FnAggHours,log(0.01_8),log(1.0e10_8),0.001_8,0.01_8,llogEpsi)
	END IF

END IF

lcapital = SUM(SUM(ksim(:,1:Ttot), DIM=1)*popsize)
lincome = (R-1)*lcapital + SUM(SUM(ysim(:,:), DIM=1)*popsize)	!gross

!assumes no death during working years
IF(MatchUsualKY==1) THEN

	simKY =lcapital/lincome
	FnBetaKY = simKY-targetKY

ELSE IF (MatchMeanK==1) THEN

	lcapitalwork = SUM(ksim(:,1:Twork)) / real(nsim*Twork)
	FnBetaKY = lcapital-targetMeanK

ELSE
	!kvec = pack(ksim(:,1:Twork),mask = ksim(:,1:Twork)<1.0e10)
	whichperc = (/ 0.5, 0.75/)
	CALL Percentiles (nsim, ksim(:,Twork), 2, whichperc, lperc)
	IF(MatchMedianK==1) FnBetaKY = lperc(1)-targetMedianK
	IF(MatchP75K==1) FnBetaKY = lperc(2)-targetP75K

END IF

if (Display>=1) write(*,*) ' Simulated - Target: ',FnBetaKY

if(Display>=1) write(*,*) ' ------------'


END FUNCTION FnBetaKY
