REAL(8) FUNCTION  FnGridFixedEffect(lx)

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

REAL(8), INTENT(IN) :: lx
REAL(8)             :: lwidth,lagrid(ngpa),ladist(ngpa),lvar,ltemp1,ltemp2,ltemp3,ltemp4,lvaralpha
INTEGER             :: ij


lvaralpha = varalpha

! get boundaries and fill in with equally spaced points
lagrid(1)    = -lx*sqrt(lvaralpha)
lagrid(ngpa) = lx*sqrt(lvaralpha)
lwidth = (lagrid(ngpa)-lagrid(1))/real(ngpa-1)
DO ij = 2, ngpa-1
    lagrid(ij) = lagrid(1) + lwidth*(ij-1)
END DO

! fill in probabilities using normal distribution
CALL cumnor( (lagrid(1)+0.5*lwidth)/sqrt(lvaralpha), ladist(1), ltemp2)	
DO ij = 2,ngpa-1
    CALL cumnor ((lagrid(ij)+0.5*lwidth)/sqrt(lvaralpha), ltemp1, ltemp2)
    CALL cumnor ((lagrid(ij)-0.5*lwidth)/sqrt(lvaralpha), ltemp3, ltemp4)
    ladist(ij) = ltemp1 - ltemp3
END DO
CALL cumnor ((lagrid(ngpa)-0.5*lwidth)/sqrt(lvaralpha), ltemp3, ladist(ngpa))
ladist = ladist/sum(ladist)

!find variance
lvar = DOT_PRODUCT(lagrid**2,ladist) - DOT_PRODUCT(lagrid,ladist)**2

!moment
FnGridFixedEffect = (lvaralpha-lvar)**2

!put values in globals
adist = ladist
agrid = lagrid


END FUNCTION FnGridFixedEffect