REAL(8) FUNCTION  FnGridHours(lx)

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

REAL(8), INTENT(IN) :: lx
REAL(8)             :: lwidth,lhgrid(ngphbar),lhdist(ngphbar),lvar,ltemp1,ltemp2,ltemp3,ltemp4,lvarhbar
INTEGER             :: ij,it

INTEGER :: ih
REAL(8) :: varhbar

varhbar=lx

lvarhbar=varhbar

! fill in hours grid as: [1/n,2/n,...,n/n]
DO ih= 1,ngphbar
    lhgrid(ih)= ih/ngphbar
END DO

! fill in probabilities using normal distribution 
CALL cumnor( (lhgrid(1)+0.5*lwidth)/sqrt(lvarhbar), lhdist(1), ltemp2)	
DO ij = 2,ngphbar-1
    CALL cumnor ((lhgrid(ij)+0.5*lwidth)/sqrt(lvarhbar), ltemp1, ltemp2)
    CALL cumnor ((lhgrid(ij)-0.5*lwidth)/sqrt(lvarhbar), ltemp3, ltemp4)
    lhdist(ij) = ltemp1 - ltemp3
END DO
CALL cumnor ((lhgrid(ngphbar)-0.5*lwidth)/sqrt(lvarhbar), ltemp3, lhdist(ngphbar))
lhdist = lhdist/sum(lhdist)

!find variance
lvar = DOT_PRODUCT(lhgrid**2,lhdist) - DOT_PRODUCT(lhgrid,lhdist)**2

!moment
FnGridHours = (lvarhbar-lvar)**2

!put values in globals
hdist = lhdist
hgrid = lhgrid

END FUNCTION FnGridHours