REAL(8) FUNCTION  FnGridPrefHet(lx)

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

REAL(8), INTENT(IN) :: lx
REAL(8)             :: lwidth,lvar,lmean,ltemp1,ltemp2,ltemp3,ltemp4,logfPgrid(ngpfP)
INTEGER             :: ij


! get boundaries and fill in with equally spaced points
fPgrid(1)    = -lx*sqrt(Vlogpsi)
fPgrid(ngpfP) = lx*sqrt(Vlogpsi)
lwidth = (fPgrid(ngpfP)-fPgrid(1))/real(ngpfP-1)
DO ij = 2, ngpfP-1
    fPgrid(ij) = fPgrid(1) + lwidth*(ij-1)
END DO

! fill in probabilities using normal distribution
CALL cumnor( (fPgrid(1)+0.5*lwidth)/sqrt(Vlogpsi), fPdist(1), ltemp2)	
DO ij = 2,ngpfP-1
    CALL cumnor ((fPgrid(ij)+0.5*lwidth)/sqrt(Vlogpsi), ltemp1, ltemp2)
    CALL cumnor ((fPgrid(ij)-0.5*lwidth)/sqrt(Vlogpsi), ltemp3, ltemp4)
    fPdist(ij) = ltemp1 - ltemp3
END DO
CALL cumnor ((fPgrid(ngpfP)-0.5*lwidth)/sqrt(Vlogpsi), ltemp3, fPdist(ngpfP))
fPdist = fPdist/sum(fPdist)

!levels, not logs
logfPgrid = fPgrid;
fPgrid = dexp(fPgrid);

!adjust mean
lmean = DOT_PRODUCT(fPgrid,fPdist)
fPgrid = fPgrid * Epsi / lmean
logfPgrid = dlog(fPgrid)

!find variance
lvar = DOT_PRODUCT(logfPgrid**2,fPdist) - DOT_PRODUCT(logfPgrid,fPdist)**2

!moment
FnGridPrefHet = (Vlogpsi-lvar)**2


END FUNCTION FnGridPrefHet