REAL(8) FUNCTION  FnGridPrefHetTrans(lx)

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

REAL(8), INTENT(IN) :: lx
REAL(8)             :: lwidth,lvar,lmean,ltemp1,ltemp2,ltemp3,ltemp4,logfTgrid(ngpfT)
INTEGER             :: ij


! get boundaries and fill in with equally spaced points
fTgrid(git,1)    = -lx*sqrt(varzeta(git))
fTgrid(git,ngpfT) = lx*sqrt(varzeta(git))
lwidth = (fTgrid(git,ngpfT)-fTgrid(git,1))/real(ngpfT-1)
DO ij = 2, ngpfT-1
    fTgrid(git,ij) = fTgrid(git,1) + lwidth*(ij-1)
END DO

! fill in probabilities using normal distribution
CALL cumnor( (fTgrid(git,1)+0.5*lwidth)/sqrt(varzeta(git)), fTdist(git,1), ltemp2)	
DO ij = 2,ngpfT-1
    CALL cumnor ((fTgrid(git,ij)+0.5*lwidth)/sqrt(varzeta(git)), ltemp1, ltemp2)
    CALL cumnor ((fTgrid(git,ij)-0.5*lwidth)/sqrt(varzeta(git)), ltemp3, ltemp4)
    fTdist(git,ij) = ltemp1 - ltemp3
END DO
CALL cumnor ((fTgrid(git,ngpfT)-0.5*lwidth)/sqrt(varzeta(git)), ltemp3, fTdist(git,ngpfT))
fTdist(git,:) = fTdist(git,:)/sum(fTdist(git,:))

!levels, not logs
logfTgrid = fTgrid(git,:);
fTgrid(git,:) = dexp(fTgrid(git,:));

!adjust mean so that mean in levels equals 1
lmean = DOT_PRODUCT(fTgrid(git,:),fTdist(git,:))
fTgrid(git,:) = fTgrid(git,:) / lmean
logfTgrid = dlog(fTgrid(git,:))

!find variance
lvar = DOT_PRODUCT(logfTgrid**2,fTdist(git,:)) - DOT_PRODUCT(logfTgrid,fTdist(git,:))**2

!moment
FnGridPrefHetTrans = (varzeta(git)-lvar)**2


END FUNCTION FnGridPrefHetTrans