REAL(8) FUNCTION  FnHoursBC(lx)

USE Parameters
USE Globals

IMPLICIT NONE

REAL(8), INTENT(IN) :: lx
REAL(8)             :: lc,lmul
REAL(8), EXTERNAL	:: FnTax

IF(LeisUtilPower==1 .and. lx>1.0) THEN  
    FnHoursBC = 100.0
    return
END IF

if(LeisUtilPower==1) lmul = gpsi*((1-lx)**(-sig))
if(HourUtilPower==1) lmul = ghbaradj*gpsi*(lx**(sig-ltax2))/(ltax1*((gwage*ghbar)**ltax2))
if(LeisUtilExpon==1) lmul = gpsi*dexp(sig*(1-lx)) 
if(HourUtilExpon==1) lmul = gpsi*dexp(sig*lx)

lc = (lmul*(1.0+ctax)/(gwage*ghbar))**(-1.0/gam)
FnHoursBC = Rnet*gass/gannprem + ghbar*gwage*lx  + gben - FnTax(ghbar*gwage*lx + gben) - gbc - lc*(1.0+ctax)

IF(isnan(FnHoursBC) .and. Display>=1) THEN
    write(*,*) 'nan in FnHoursBC'
END IF

END FUNCTION FnHoursBC