REAL(8) FUNCTION FnSSParam(lsspar)
USE Parameters
USE Globals
IMPLICIT NONE

REAL(8), INTENT(IN) :: lsspar
INTEGER         :: it,iz,ia,ip
REAL(8)     ::ltotpen,lavearns,lavwage,ltotearns,lmearns,lavpen

IF (Display>=2)write(*,*) ' SS benefit parameter: ', lsspar

lavwage = DOT_PRODUCT(avwage, popsize(1:Twork)) / SUM(popsize(1:Twork))
ltotearns = DOT_PRODUCT(avwage, popsize(1:Twork))*targethours
lavearns = ltotearns/SUM(popsize(1:Twork))

IF (ScaleBendPoints==1) THEN    
    ssbend1 = 0.18*lsspar*lavearns 
    ssbend2 = 1.1*lsspar*lavearns 
ELSE
    ssbend1 = 0.18*lavearns
    ssbend2 = 1.1*lavearns
END IF

ltotpen = 0.0
ip = 1
DO iz = 1,ngpz
DO ia = 1,ngpa
    pind(iz,ia) = ip    
    DO it = 1,Tret
        IF (FlatPension==1) THEN

			lmearns = lavearns
            pgrid(it,ip)  = lmearns

        ELSE IF (LinearPension==1) THEN
			IF(PensionFEOnly==1) THEN
				lmearns = targethours*DOT_PRODUCT(wgrid(:,ia,(ngpz+1)/2,(ngpe+1)/2), popsize(1:Twork)) / SUM(popsize(1:Twork))
            ELSE
				lmearns = targethours*DOT_PRODUCT(wgrid(:,ia,iz,(ngpe+1)/2), popsize(1:Twork)) / SUM(popsize(1:Twork))
			END IF
			pgrid(it,ip)  = lmearns

        ELSE IF (ConcavePension==1) THEN    
			IF(PensionFEOnly==1) THEN
				lmearns = targethours*DOT_PRODUCT(wgrid(:,ia,(ngpz+1)/2,(ngpe+1)/2), popsize(1:Twork)) / SUM(popsize(1:Twork))
            ELSE
				lmearns = targethours*DOT_PRODUCT(wgrid(:,ia,iz,(ngpe+1)/2), popsize(1:Twork)) / SUM(popsize(1:Twork))
			END IF
            
			IF (lmearns <= ssbend1) THEN			
                pgrid(it,ip) = 0.9*lmearns
            ELSE IF (lmearns <= ssbend2) THEN
                pgrid(it,ip) = 0.9*ssbend1 + 0.32*(lmearns - ssbend1)
            ELSE
                pgrid(it,ip) = 0.9*ssbend1 + 0.32*(ssbend2-ssbend1) + 0.15*(lmearns - ssbend2)
            END IF 

        END IF

		IF (ScaleBendPoints==0) pgrid(it,ip) = pgrid(it,ip)*lsspar
        
        ltotpen = ltotpen + pgrid(it,ip)*zdist(Twork,iz)*adist(ia)*popsize(Twork+it)
    END DO        
    ip = ip+1
END DO
END DO

IF (MatchTotPenBen==1) THEN
	FnSSParam = ltotpen/ltotearns - targetSSBenToLabinc
	IF (Display>=2)write(*,*) ' SS Ben / Labor income: ', (ltotpen/ltotearns)*100, '%'
ELSE !match average average pension benefit as fraction of average earnings
	lavpen = ltotpen/SUM(popsize(Twork+1:Ttot))
	FnSSParam = lavpen/lavearns - targetSSAvBen
	IF (Display>=2)write(*,*) ' av pension / av labor inc: ', (lavpen/lavearns)*100, '%'
 
END IF
    
END FUNCTION FnSSParam

