SUBROUTINE LoadData

USE Parameters
USE Globals

IMPLICIT NONE

INTEGER :: it
REAL(8) :: unconsurprob(Ttot),lmoments1PSID(2,36),lmoments2PSID(3,36),lmoments2CEX(18,36),lmoments1CEX(6,36)
INTEGER	:: lnPSID(5,36),lnCEX(24,36)
REAL(8)	:: lstdPSID(5,36),lstd2CEX(18,36),lstd1CEX(6,36) 
CHARACTER(len=1000) :: charbs

!set up directories to read from
IF (DoBootstraps==0) THEN

	DataDir = DataBaseDir
	InputWageEstDir = InputWageEstBaseDir 

ELSE IF (DoBootstraps==1) THEN

	write(charbs,*) gibs
	charbs = adjustl(charbs)
	DataDir = trim(DataBaseDir) // 'bs' // trim(charbs)  // filesep
	InputWageEstDir = trim(InputWageEstBaseDir) // 'bs' // trim(charbs)  // filesep

END IF

!wage parameters
OPEN(1, FILE = trim(DataDir) // 'kappasmooth.txt')
READ(1,*) kappa
CLOSE(1)

OPEN(1, FILE = trim(InputWageEstDir) // 'varalpha.txt')
READ(1,*) varalpha
CLOSE(1)

OPEN(1, FILE = trim(InputWageEstDir) // 'vareta.txt')
READ(1,*) vareta
CLOSE(1)

OPEN(1, FILE = trim(InputWageEstDir) // 'vareps_vec.txt')
READ(1,*) vareps
CLOSE(1)

OPEN(1, FILE = trim(InputWageEstDir) // 'rho.txt')
READ(1,*) rho
CLOSE(1)

!unemployment weeks
OPEN(1, FILE = trim(InputDir) // 'unemppossmooth.txt')
READ(1,*) unemppos
CLOSE(1)

!survival probabilities
surprob(1:Twork) = 1.0
OPEN(1, FILE = trim(InputDir) // 'surprob.txt')
READ(1,*) surprob(Twork+1:Ttot)
CLOSE(1)

IF (NoDeathProb==1) THEN
	surprob(1:Ttot-1) = 1.0
END IF

unconsurprob(1) = 1.0
annprem(1)  = 1.0
DO it = 2,Ttot
    unconsurprob(it) = unconsurprob(it-1)* surprob(it-1)
	IF (AnnuityMarkets == 1) THEN
		annprem(it) = surprob(it-1)
	ELSE
		annprem(it) = 1.0
	END IF
END DO

DO it = 1,Ttot
    popsize(it) = unconsurprob(it)/real(sum(unconsurprob))
END DO

!data moments to match: PSID
OPEN(1, FILE = trim(DataDir) // 'firstmomentsDataPSID.txt')
READ(1,*) lmoments1PSID
CLOSE(1)
dataEh		= lmoments1PSID(1,:)
dataElogh	= lmoments1PSID(2,:)

OPEN(1, FILE = trim(DataDir) // 'secondmomentsDataPSID.txt')
READ(1,*) lmoments2PSID
CLOSE(1)
dataVh 		= lmoments2PSID(1,:)
dataCOVwh	= lmoments2PSID(2,:)
dataPk0neg	= lmoments2PSID(3,:)

OPEN(1, FILE = trim(DataDir) // 'momentsNPSID.txt')
READ(1,*) lNPSID
CLOSE(1)
NVh 	= lNPSID(1,:)
NCOVwh	= lNPSID(2,:)
NPk0neg	= lNPSID(3,:)
NEh		= lNPSID(4,:)
NElogh	= lNPSID(5,:)

!data moments to match: CEX
OPEN(1, FILE = trim(DataDir) // 'firstmomentsDataCEX.txt')
READ(1,*) lmoments1CEX
CLOSE(1)
dataElogc	= lmoments1CEX(EquivalenceScale,:)

OPEN(1, FILE = trim(DataDir) // 'secondmomentsDataCEX.txt')
READ(1,*) lmoments2CEX
CLOSE(1)
dataVc 		= lmoments2CEX((EquivalenceScale-1)*3+1,:)
dataCOVcw	= lmoments2CEX((EquivalenceScale-1)*3+2,:)
dataCOVch	= lmoments2CEX((EquivalenceScale-1)*3+3,:)

OPEN(1, FILE = trim(DataDir) // 'momentsNCEX.txt')
READ(1,*) lnCEX
CLOSE(1)
NVc 	= lnCEX((EquivalenceScale-1)*3+1,:)
NCOVcw	= lnCEX((EquivalenceScale-1)*3+2,:)
NCOVch	= lnCEX((EquivalenceScale-1)*3+3,:)
NElogc	= lnCEX((EquivalenceScale-1)*3+4,:)

!st dev of moments for variance weighting: at the moment I use the same matrix in every bootstrap replication. correct?
OPEN(1, FILE = trim(DataBaseDir) // 'stdmomentsPSID.txt')
READ(1,*) lstdPSID
CLOSE(1)
stdevVh 		= lstdPSID(1,:)
stdevCOVwh	= lstdPSID(2,:)
stdevPk0neg	= lstdPSID(3,:)
stdevEh		= lstdPSID(4,:)
stdevElogh	= lstdPSID(5,:)

OPEN(1, FILE = trim(DataBaseDir) // 'stdfirstmomentsCEX.txt')
READ(1,*) lstd1CEX
CLOSE(1)
stdevElogc	= lstd1CEX(EquivalenceScale,:)

OPEN(1, FILE = trim(DataBaseDir) // 'stdsecondmomentsCEX.txt')
READ(1,*) lstd2CEX
CLOSE(1)
stdevVc 	= lstd2CEX((EquivalenceScale-1)*3+1,:)
stdevCOVcw	= lstd2CEX((EquivalenceScale-1)*3+2,:)
stdevCOVch	= lstd2CEX((EquivalenceScale-1)*3+3,:)


END SUBROUTINE LoadData