PROGRAM Main

USE Parameters
USE Globals

IMPLICIT NONE
INTEGER	:: iflag
INTEGER	:: count


IF (RunOnLinux==0) filesep = '\'
IF (RunOnLinux==1) filesep = '/'

IF (ReadParameterFile==1) THEN
	count = NARGS()
	IF (count<2) THEN
		write(*,*) "need guess file name as argument if ReadGuessFile==1"
		stop
	ELSE
		CALL GETARG(1,InputParamFile)
	END IF
END IF

CALL DrawRandomNumbers

IF (DoEstimation==0 .and. DoBootstraps==0) THEN

    CALL SetParameters
    CALL LoadData

	IF (MatchAggHours==0) THEN
	    CALL Grids
	    IF (MatchKYRatio==0) THEN        
	        CALL Decisions
	        CALL Simulate     
    	END IF
		IF (MatchKYRatio==1 ) CALL rtsecBetaKY(bet,bet*1.01,0.01_8)
	END IF

	IF (MatchAggHours==1) THEN
	    IF (MatchKYRatio==0 ) THEN
	        if(LeisUtilPower==1) CALL rtsecAggHours(log(Epsi),log(Epsi*0.8),0.001_8,iflag)
	        if(HourUtilPower==1) CALL rtsecAggHours(log(Epsipow),log(Epsipow*2.0),0.001_8,iflag)
	        if(LeisUtilExpon==1 .or. HourUtilExpon==1) CALL rtsecAggHours(Elogpsi,Elogpsi*0.8,0.001_8,iflag)
	    END IF
	    IF (MatchKYRatio==1) CALL rtsecBetaKY(bet,bet*1.01,0.01_8)	
	END IF

	CALL CalculateStats
	CALL SaveOutput

ELSE IF (DoEstimation==1 .and. DoBootstraps==0) THEN

    CALL SetParameters
    CALL LoadData
	CALL Estimation
	CALL Grids
    CALL Decisions
    CALL Simulate     
	CALL CalculateStats
	CALL SaveOutput
	
ELSE IF (DoEstimation==1 .and. DoBootstraps==1) THEN

	DO gibs = 1,nbstraps
	
		write(*,*) 'RUNNING BOOTSTRAP REPLICATION ',gibs
				
	    CALL SetParameters
	    CALL LoadData
		CALL Estimation
		CALL Grids
	    CALL Decisions
	    CALL Simulate     
		CALL CalculateStats
		CALL SaveOutput
		
	END DO

END IF

END PROGRAM Main