# delimit;
set more 1;

clear;
set mem 1g;
set logtype text;

*parameters;
global FortranDir "/Volumes/FILES/Large/LifecycleInequality/inequalityresults_july1/2GYearg1/final/";
global Twork 36;
global Tret 30;
global Ttot 66;
global Ttot1 67;
global Nsim 10000;

*create data set to append files to;
cd $FortranDir;
clear;
set obs $Nsim;
gen id = _n;
sort id;
compress;
save Simulations.dta, replace;

*read in files from fortran - Ttot;
foreach var in ysim csim cgrosim ynetsim mucsim{; *;
    clear;
    insheet using `var'.txt;
    gen id = _n;
    forvalues i = 1/$Ttot{;
        rename v`i' `var'`i';
    }; 
    sort id;
    compress;
    merge id using Simulations.dta;
    tab _merge;
    drop _merge;
    sort id;
	save Simulations.dta, replace;
};

*read in files from fortran - Ttot+1;
foreach var in ksim{; *;
    clear;
    insheet using `var'.txt;
    gen id = _n;
    forvalues i = 1/$Ttot1{;
        rename v`i' `var'`i';
    }; 
    sort id;
    compress;
    merge id using Simulations.dta;
    tab _merge;
    drop _merge;
    sort id;
	save Simulations.dta, replace;
};

*read in files from fortran - Twork;
foreach var in wsim hsim hbarsim htotsim bsim mulsim taxsim fsim{; *;
    clear;
    insheet using `var'.txt;
    gen id = _n;
    forvalues i = 1/$Twork{;
        rename v`i' `var'`i';
    }; 
    sort id;
    compress;
    merge id using Simulations.dta;
    tab _merge;
    drop _merge;
    sort id;
	save Simulations.dta, replace;
};

*read in files from fortran - Tret;
foreach var in psim{; *;
    clear;
    insheet using `var'.txt;
    gen id = _n;
    forvalues i = 1/$Tret{;
		local t = $Twork +`i';
        rename v`i' `var'`t';
    }; 
    sort id;
    compress;
    merge id using Simulations.dta;
    tab _merge;
    drop _merge;
    sort id;
	save Simulations.dta, replace;
};

use Simulations.dta, clear;
reshape long ysim csim mucsim ksim wsim hsim hbarsim htotsim bsim mulsim psim ynetsim cgrosim taxsim fsim, i(id) j(year);
compress;
iis id;
tsset id year;
save Simulations_long.dta, replace;

*read in files from fortran - fixed;
foreach var in asim {; *;
    clear;
    insheet using `var'.txt;
	rename v1 `var';
	cap drop v2;
    gen id = _n;
    sort id;
    compress;
    merge id using Simulations_long.dta;
    tab _merge;
    drop _merge;
    sort id;
	save Simulations_long.dta, replace;
};

order id year ksim wsim htotsim hsim hbar ysim csim bsim psim fsim asim;
sort id year;
save Simulations_long.dta, replace;
