SUBROUTINE MomentConditions(lnpar,ly,lf,lfvec)

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE

INTEGER, INTENT(IN)     					:: lnpar
REAL(8), DIMENSION(lnpar), INTENT(IN)  	:: ly   !length lnpar
REAL(8), INTENT(OUT) 					:: lf,lfvec(nmoments)
INTEGER     	:: ip
REAL(8)			:: lx(lnpar),lavVlogc,lavdataVlogc,lavVlogh,lavdataVlogh,lJ

lx = ly/paramscale
! write(*,*) 'lx is: ',lx

write(4,*) '*********************************'
write(4,*) 'EVALUATION NUMBER: ',objeval

!Extract parameters
ip = 0
IF(EstimateGamma==1) THEN
    ip=ip+1
    IF (UseBoundConstraints==1)gam = lx(ip) !paramlb(ip) + ((lx(ip)+1.0)/2.0)*(paramub(ip)-paramlb(ip))
    IF (UseBoundConstraints==0)gam = exp(lx(ip))
	write(4,*) ' gam guess: ',gam
END IF

IF(EstimateSigma==1) THEN
    ip=ip+1
    IF (UseBoundConstraints==1)sig = lx(ip) !paramlb(ip) + ((lx(ip)+1.0)/2.0)*(paramub(ip)-paramlb(ip))
    IF (UseBoundConstraints==0)    sig = exp(lx(ip)) + 1.0
	write(4,*) ' sig guess: ',sig
	IF(sig>200.0) THEN
		sig=200.0
		write(4,*) '  sig censored at 200.0'
	END IF
END IF

IF(EstimateMeanPref==1) THEN
    ip=ip+1
    IF (UseBoundConstraints==1)Epsipow = lx(ip)
    IF (UseBoundConstraints==0)	Epsipow = exp(lx(ip))
	write(4,*) ' Epsipow guess: ',Epsipow
ELSE
	Epsipow = EpsipowG	!re-set intitial guess for robustness
END IF

IF(EstimateVarPref==1) THEN
    ip=ip+1
    IF (UseBoundConstraints==1)CVpsipow = lx(ip)
    IF (UseBoundConstraints==0)	CVpsipow = exp(lx(ip))
	write(4,*) ' CVpsipow guess: ',CVpsipow
END IF

IF(EstimateVarPrefTrans==1) THEN
    ip=ip+1
    IF (UseBoundConstraints==1)CVzetapow = lx(ip)
    IF (UseBoundConstraints==0)	CVzetapow = exp(lx(ip))
	write(4,*) ' CVzetapow guess: ',CVzetapow
END IF

IF(EstimateRhoPref==1) THEN
    ip=ip+1
    IF (UseBoundConstraints==1)	rhopref = lx(ip)
    IF (UseBoundConstraints==0)	rhopref = lx(ip)
	write(4,*) ' rhopref guess: ',rhopref
END IF

IF(EstimateBeta==1) THEN
    ip=ip+1
    IF (UseBoundConstraints==1)bet = lx(ip)
    IF (UseBoundConstraints==0)    bet = logistic(lx(ip))
	write(4,*) ' bet guess: ',bet
END IF

IF(EstimateChi==1) THEN
    ip=ip+1
    IF (UseBoundConstraints==1)chi = lx(ip)

!     IF (UseBoundConstraints==0)	chi = 1.0-exp(lx(ip))
    IF (UseBoundConstraints==0)	THEN
		chitild = exp(lx(ip))
		chi = 1.0-chitild/(1.0+sig)
	END IF
	write(4,*) ' chi tild guess: ',chitild
	write(4,*) ' chi guess: ',chi
END IF

IF(EstimateBorrowLim==1) THEN
    ip=ip+1
    IF (UseBoundConstraints==1)borrowlim = lx(ip)
    IF (UseBoundConstraints==0)	borrowlim = -exp(lx(ip))
	write(4,*) ' borrowlim guess: ',borrowlim
	IF(borrowlim<-10.0) THEN
		borrowlim=-10.0
		write(4,*) '  borrowlim censored at -10.0'
	END IF
END IF

IF(EstimateErrC==1) THEN
    ip=ip+1
    IF (UseBoundConstraints==1)err_c = lx(ip)
    IF (UseBoundConstraints==0)	err_c = exp(lx(ip))
	write(4,*) ' err c guess: ',err_c
ELSE
	err_c = err_cG	!because they get changed below
END IF

IF(EstimateErrY==1) THEN
    ip=ip+1
    IF (UseBoundConstraints==1)err_y = lx(ip)
    IF (UseBoundConstraints==0)	err_y = exp(lx(ip))
	write(4,*) ' err y guess: ',err_y
ELSE
	err_y = err_yG	!because they get changed below
END IF

IF(EstimateErrH==1) THEN
    ip=ip+1
    IF (UseBoundConstraints==1)err_h = lx(ip)
    IF (UseBoundConstraints==0)	err_h = exp(lx(ip))
	write(4,*) ' err h guess: ',err_h
ELSE
	err_h = err_hG	!because they get changed below
END IF

! Elogpsi = log(Epsi) - Vlogpsi/2.0
Vpsipow = (Epsipow*CVpsipow)**2.0
Vlogpsipow = log(Vpsipow/(Epsipow**2.0) +1.0)
Elogpsipow = log(Epsipow) - Vlogpsipow/2.0
Elogpsi = (1.0-gam)*Elogpsipow - (gam+sig)*log(targethours)
Epsi = exp((1.0-gam)*Elogpsipow +((1.0-gam)**2.0)*Vlogpsipow/2.0) / (targethours**(sig+gam))
Vlogpsi = ((1.0-gam)**2.0)*Vlogpsipow
Vlogzeta = (1.0-gamG**2.0)*log(CVzetapow**2.0+1.0)

err_w = err_h + err_y
  
!Solve Model: need to decide about Epsi and aggregate hours
if(Display>=1) write(*,*) '**************************************************'
IF ((MatchKYRatio==0 .or. EstimateBeta==1) .and. (MatchAggHours==0 .or. EstimateMeanPref==1)) THEN
    CALL Grids
    CALL Decisions
    CALL Simulate
    CALL CalculateStats
ELSE IF (EstimateBeta==0 .and. MatchKYRatio==1 .and.  (MatchAggHours==0 .or. EstimateMeanPref==1)) THEN
	CALL Grids
	!need a better way to guess beta here:
	IF(bet<0.9 .or. bet>1.05) bet = betG
	CALL rtsecBetaKY(bet,bet*1.01,0.05_8)
    CALL CalculateStats    
ELSE IF (EstimateBeta==0 .and. MatchKYRatio==1 .and.  MatchAggHours==1 .and. EstimateMeanPref==0) THEN
	CALL Grids
	!need a better way to guess beta here:
	IF(bet<0.9 .or. bet>1.05) bet = betG
	CALL rtsecBetaKY(bet,bet*1.01,0.05_8)
    CALL CalculateStats    
END IF

!moments to match: need to include weights
ip = 0
IF (MatchMeanCon == 1) THEN
	lfvec(1:Twork) = (Elogc(1:Twork)-Elogc(1)) - (dataElogc - dataElogc(1)) !only match slope not level for log consumption
	IF(UseDiagWeight==1) THEN
		diagweight(1) = 0
		diagweight(2:Twork) = 1.0/(stdevElogc(2:Twork)**2.0)
		nobsvec(1:Twork)= NElogc
	END IF
	ip = ip + Twork
END IF

IF (MatchMeanHour == 1) THEN
	IF(MatchMeansInLogs==1) THEN
		lfvec(ip+1:ip+Twork) = Eloghtot - dataElogh
		IF(UseDiagWeight==1) diagweight(ip+1:ip+Twork) = 1.0/(stdevElogh**2.0)
		nobsvec(ip+1:ip+Twork) = NElogh
	END IF
	
	IF(MatchMeansInLogs==0) THEN
		lfvec(ip+1:ip+Twork) = Ehtot - dataEh
		IF(UseDiagWeight==1) diagweight(ip+1:ip+Twork) = 1.0/(stdevEh**2.0)
		nobsvec(ip+1:ip+Twork) = NEh
	END IF
	ip = ip + Twork
END IF

IF (MatchVarCon == 1) THEN
	!measurement error in consumption
	IF (EstimateErrC==0) THEN
		lavVlogc = sum(Vlogc(1:Twork))/real(Twork)
		lavdataVlogc = sum(dataVc)/real(Twork)
		err_c = max(lavdataVlogc - lavVlogc,0.0)
	END IF
	lfvec(ip+1:ip+Twork) = Vlogc(1:Twork) - (dataVc -err_c)
	IF(UseDiagWeight==1) diagweight(ip+1:ip+Twork) = 1.0/(stdevVc**2.0)
	nobsvec(ip+1:ip+Twork) = NVc
	ip = ip + Twork
END IF

IF (MatchVarHour == 1) THEN
	!measurement error in hours
	IF (EstimateErrH==0) THEN
		lavVlogh = sum(Vloghtot)/real(Twork)
		lavdataVlogh = sum(dataVh)/real(Twork)
		err_h = max(lavdataVlogh - lavVlogh,0.0)
		IF(EstimateErrY==0) err_y = max(err_w-err_h,0.0)
	END IF
	lfvec(ip+1:ip+Twork) = Vloghtot - (dataVh -err_h)
	IF(UseDiagWeight==1) diagweight(ip+1:ip+Twork) = 1.0/(stdevVh**2.0)
	nobsvec(ip+1:ip+Twork) = NVh
	ip = ip + Twork
END IF

IF (MatchCovWageHour == 1) THEN	
	lfvec(ip+1:ip+Twork) = COVwhtot_hpos - (dataCOVwh +err_h)
	IF(UseDiagWeight==1) diagweight(ip+1:ip+Twork) = 1.0/(stdevCOVwh**2.0)
	nobsvec(ip+1:ip+Twork) = NCOVwh
	ip = ip + Twork
END IF

IF (MatchCovConWage == 1) THEN	
	lfvec(ip+1:ip+Twork) = COVcw_hpos - dataCOVcw
	IF(UseDiagWeight==1) diagweight(ip+1:ip+Twork) = 1.0/(stdevCOVcw**2.0)
	nobsvec(ip+1:ip+Twork) = NCOVcw
	ip = ip + Twork
END IF

IF (MatchCovConHour == 1) THEN
	lfvec(ip+1:ip+Twork) = COVchtot_hpos - dataCOVch
	IF(UseDiagWeight==1) diagweight(ip+1:ip+Twork) = 1.0/(stdevCOVch**2.0)
	nobsvec(ip+1:ip+Twork) = NCOVch
	ip = ip + Twork
END IF

IF (MatchZeroNegWealth == 1) THEN
	lfvec(ip+1:ip+Twork) = Pk0neg(1:Twork) - dataPk0neg
	IF(UseDiagWeight==1) diagweight(ip+1:ip+Twork) = 1.0/(stdevPk0neg**2.0)
	nobsvec(ip+1:ip+Twork) = NPk0neg
	ip = ip + Twork
END IF


!construct objective function manually as well:
lf = sum((lfvec**2.0)*diagweight)/real(nmoments)
write(4,*) 'objective fun: ',lf

!get J statistic
IF(UseDiagWeight==1) THEN
	lJ = sum((lfvec**2.0)*diagweight)
	write(4,*) 'J statistic is ',lJ, ' with ',nmoments-nparam ,' df'
END IF

write(4,*) ' '

objeval = objeval+1
END SUBROUTINE MomentConditions