	SUBROUTINE rtbisHoursBC(x1,x2,xacc,xout,info)
	IMPLICIT NONE
	REAL(8), INTENT(IN) :: x1,x2,xacc
	REAL(8), INTENT(OUT) :: xout
	INTEGER, INTENT(OUT) :: info
	REAL(8) :: rtbis
	INTEGER, PARAMETER :: MAXIT=30
	INTEGER :: j
	REAL(8) :: dx,f,fmid,xmid
	REAL(8), EXTERNAL	:: FnHoursBC
	info = 0
	fmid=FnHoursBC(x2)
	f=FnHoursBC(x1)
	if (f*fmid >= 0.0) then
		write(*,*)'rtbisHoursBC: root must be bracketed'
		write(*,*) 'x1, f1: ',x1,f  
		write(*,*) 'x2, f2: ',x2,fmid  
		info = -1
		return
	end if
	if (f < 0.0) then
		rtbis=x1
		dx=x2-x1
	else
		rtbis=x2
		dx=x1-x2
	end if
	do j=1,MAXIT
		dx=dx*0.5_8
		xmid=rtbis+dx
		fmid=FnHoursBC(xmid)
		if (fmid <= 0.0) rtbis=xmid
		if (abs(dx) < xacc .or. fmid == 0.0) then
			xout = rtbis
			info = 1
			RETURN
		end if
	end do
	info = 0
	write(*,*)'rtbisHoursBC: too many bisections'
	END SUBROUTINE rtbisHoursBC
