SUBROUTINE rtflspHoursBC(lx1,lx2,xacc,lx,info)

IMPLICIT NONE

REAL(8), INTENT(IN) :: lx1,lx2,xacc
REAL(8), INTENT(OUT) :: lx
INTEGER, INTENT(OUT) :: info
REAL(8) :: rtflsp

INTEGER, PARAMETER :: MAXIT=40
INTEGER :: j
REAL(8) :: del,dx,f,fh,fl,xh,xl,x1,x2
REAL(8), EXTERNAL        :: FnHoursBC

info = 0
x1 = lx1
x2 = lx2

fl=FnHoursBC(x1)
fh=FnHoursBC(x2)

if ((fl > 0.0 .and. fh > 0.0) .or. 	(fl < 0.0 .and. fh < 0.0)) then
    write(*,*) ('rtflsp: root must be bracketed between arguments')
end if

if (fl < 0.0) then
	xl=x1
	xh=x2
else
	xl=x2
	xh=x1
    f=fl
    fl=fh
    fh=f
end if

dx=xh-xl
do j=1,MAXIT
	rtflsp=xl+dx*fl/(fl-fh)
	f=FnHoursBC(rtflsp)
	if (f < 0.0) then
		del=xl-rtflsp
		xl=rtflsp
		fl=f
	else
		del=xh-rtflsp
		xh=rtflsp
		fh=f
	end if
	dx=xh-xl
	lx = rtflsp
	if (abs(del) < xacc .or. abs(f) <1.0e-6) then
		info = 1
		RETURN
	end if
end do

info = -1
!write(*,*) ('rtflspHoursBC: exceed maximum iterations')
END SUBROUTINE rtflspHoursBC
