SUBROUTINE rtsecAggHours(lx1,lx2,facc,iflag)

IMPLICIT NONE

REAL(8), INTENT(IN) :: lx1,lx2,facc
INTEGER, INTENT(OUT)	:: iflag
REAL(8) :: rtsec,x1,x2
INTEGER, PARAMETER :: MAXIT=30
INTEGER :: j
REAL(8) :: dx,f,fl,xl,ltemp

REAL(8), EXTERNAL        :: FnAggHours

iflag = 0

x1 = lx1
x2 = lx2

fl=FnAggHours(x1)
if (abs(fl)<facc) return

f=FnAggHours(x2)
if (abs(f)<facc) return

if (abs(fl) < abs(f)) then
	rtsec=x1
	xl=x2
	ltemp = fl
	fl = f
	f = ltemp
else
	xl=x1
	rtsec=x2
end if

do j=1,MAXIT
	
!    write(*,*) 'f-f1=', f-fl
!    write(*,*) 'xl-x2=', xl-rtsec
	dx=(xl-rtsec)*f/(f-fl)
	xl=rtsec
	fl=f
	rtsec=rtsec+dx
	f=FnAggHours(rtsec)
    if (abs(f)<facc) return
	if(fl==f) then
		iflag = 1
		write(*,*) 'rtsecAgghours: stuck, reverting to bisection'
		return
	end if

end do
	
write(*,*)('rtsec: exceed maximum iterations')

END SUBROUTINE rtsecAggHours