SUBROUTINE rtsecHoursBC(lx1,lx2,facc,lx,info)

IMPLICIT NONE

REAL(8), INTENT(IN) :: lx1,lx2,facc
REAL(8), INTENT(OUT) :: lx
INTEGER, INTENT(OUT) :: info
REAL(8) :: rtsec,x1,x2
INTEGER, PARAMETER :: MAXIT=15
INTEGER :: j
REAL(8) :: dx,f,fl,xl,ltemp

REAL(8), EXTERNAL        :: FnHoursBC


info = 0

x1 = lx1
x2 = lx2

fl=FnHoursBC(x1)
if (abs(fl)<facc) then 
    lx = lx1
	info = 1
    return
end if

f=FnHoursBC(x2)
if (abs(f)<facc) then 
    lx = lx2
	info = 1
    return
end if

if (abs(fl) < abs(f)) then
	rtsec=x1
	xl=x2
	ltemp = fl
	fl = f
	f = ltemp
else
	xl=x1
	rtsec=x2
end if

do j=1,MAXIT
	if(f==fl) then
		info = -1
		return
	end if
	dx=(xl-rtsec)*f/(f-fl)
	xl=rtsec
	fl=f
	rtsec=rtsec+dx
	f=FnHoursBC(rtsec)
    if (abs(f)<facc) then 
        lx = rtsec
		info = 1
        return
    end if    
end do

info = -1	
!write(*,*)('rtsecHoursBC: exceed maximum iterations')

END SUBROUTINE rtsecHoursBC