SUBROUTINE SaveOutput

USE Parameters
USE Globals
USE Procedures

IMPLICIT NONE


write(*,*) ' Saving output to disk'



! Scalars
OPEN(3, FILE = trim(OutputDir) // 'Twork.txt', STATUS = 'replace'); WRITE(3,*) Twork; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // 'Tret.txt', STATUS = 'replace'); WRITE(3,*) Tret; CLOSE(3)
OPEN(3, FILE = trim(OutputDir) // 'Ttot.txt', STATUS = 'replace'); WRITE(3,*) Ttot; CLOSE(3)
OPEN(3, FILE = trim(OutputDir)// 'nsim.txt', STATUS = 'replace'); WRITE(3,*) nsim; CLOSE(3)
OPEN(3, FILE = trim(OutputDir)// 'err_w.txt', STATUS = 'replace'); WRITE(3,*) err_w; CLOSE(3)
OPEN(3, FILE = trim(OutputDir)// 'err_c.txt', STATUS = 'replace'); WRITE(3,*) err_c; CLOSE(3)
OPEN(3, FILE = trim(OutputDir)// 'err_h.txt', STATUS = 'replace'); WRITE(3,*) err_h; CLOSE(3)

! Tret length vectors
OPEN(3, FILE = trim(OutputDir) // 'Ep.txt', STATUS = 'replace'); CALL WriteMatrix(3,Tret,1,Ep)
OPEN(3, FILE = trim(OutputDir) // 'Elogp.txt', STATUS = 'replace'); CALL WriteMatrix(3,Tret,1,Elogp)

! Ttot length vectors
OPEN(3, FILE = trim(OutputDir) // 'Ec.txt', STATUS = 'replace'); CALL WriteMatrix(3,Ttot,1,Ec)
OPEN(3, FILE = trim(OutputDir) // 'Ek.txt', STATUS = 'replace'); CALL WriteMatrix(3,Ttot,1,Ek)
OPEN(3, FILE = trim(OutputDir) // 'Pk0neg.txt', STATUS = 'replace'); CALL WriteMatrix(3,Ttot,1,Pk0neg)
OPEN(3, FILE = trim(OutputDir) // 'Elogc.txt', STATUS = 'replace'); CALL WriteMatrix(3,Ttot,1,Elogc)
OPEN(3, FILE = trim(OutputDir) // 'Elogk.txt', STATUS = 'replace'); CALL WriteMatrix(3,Ttot,1,Elogk)
OPEN(3, FILE = trim(OutputDir) // 'Vlogc.txt', STATUS = 'replace'); CALL WriteMatrix(3,Ttot,1,Vlogc)
OPEN(3, FILE = trim(OutputDir) // 'Vlogk.txt', STATUS = 'replace'); CALL WriteMatrix(3,Ttot,1,Vlogk)

! Twork length vectors
OPEN(3, FILE = trim(OutputDir) // 'Eh.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Eh)
OPEN(3, FILE = trim(OutputDir) // 'Phpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Phpos)
OPEN(3, FILE = trim(OutputDir) // 'Ehpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Ehpos)
OPEN(3, FILE = trim(OutputDir) // 'Phft.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Phft)
OPEN(3, FILE = trim(OutputDir) // 'Ehft.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Ehft)
OPEN(3, FILE = trim(OutputDir) // 'Ew.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Ew)
OPEN(3, FILE = trim(OutputDir) // 'Ew_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Ew_hpos)
OPEN(3, FILE = trim(OutputDir) // 'Ey.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Ey)
OPEN(3, FILE = trim(OutputDir) // 'Elogh.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Elogh)
OPEN(3, FILE = trim(OutputDir) // 'Elogw.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Elogw)
OPEN(3, FILE = trim(OutputDir) // 'Elogw_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Elogw_hpos)
OPEN(3, FILE = trim(OutputDir) // 'Elogy.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Elogy)
OPEN(3, FILE = trim(OutputDir) // 'Elogc_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Elogc_hpos)
OPEN(3, FILE = trim(OutputDir) // 'Elogh_kpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Elogh_kpos)
OPEN(3, FILE = trim(OutputDir) // 'Eloghtot_kpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Eloghtot_kpos)
OPEN(3, FILE = trim(OutputDir) // 'Elogw_kpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Elogw_kpos)
OPEN(3, FILE = trim(OutputDir) // 'Elogw_khpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Elogw_khpos)
OPEN(3, FILE = trim(OutputDir) // 'Elogk_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Elogk_hpos)

OPEN(3, FILE = trim(OutputDir) // 'Ehtot.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Ehtot)
OPEN(3, FILE = trim(OutputDir) // 'Ehbar.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Ehbar)
OPEN(3, FILE = trim(OutputDir) // 'Eloghbar.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Eloghbar)
OPEN(3, FILE = trim(OutputDir) // 'Eloghtot.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Eloghtot)


OPEN(3, FILE = trim(OutputDir) // 'Vh.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Vh)
OPEN(3, FILE = trim(OutputDir) // 'Vk.txt', STATUS = 'replace'); CALL WriteMatrix(3,Ttot,1,Vk)
OPEN(3, FILE = trim(OutputDir) // 'GINIk.txt', STATUS = 'replace'); CALL WriteMatrix(3,Ttot,1,GINIk)

OPEN(3, FILE = trim(OutputDir) // 'Vlogh.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Vlogh)
OPEN(3, FILE = trim(OutputDir) // 'Vlogh_ft.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Vlogh_ft)
OPEN(3, FILE = trim(OutputDir) // 'Vlogw.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Vlogw)
OPEN(3, FILE = trim(OutputDir) // 'Vlogw_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Vlogw_hpos)
OPEN(3, FILE = trim(OutputDir) // 'Vlogc_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Vlogc_hpos)
OPEN(3, FILE = trim(OutputDir) // 'Vlogy.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Vlogy)

OPEN(3, FILE = trim(OutputDir) // 'Vhbar.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Vhbar)
OPEN(3, FILE = trim(OutputDir) // 'Vloghbar.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Vloghbar)
OPEN(3, FILE = trim(OutputDir) // 'Vhtot.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Vhtot)
OPEN(3, FILE = trim(OutputDir) // 'Vloghtot.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,Vloghtot)

OPEN(3, FILE = trim(OutputDir) // 'COVwh_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,COVwh_hpos)
OPEN(3, FILE = trim(OutputDir) // 'COVcw_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,COVcw_hpos)
OPEN(3, FILE = trim(OutputDir) // 'COVch_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,COVch_hpos)
OPEN(3, FILE = trim(OutputDir) // 'COVcw.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,COVcw)

OPEN(3, FILE = trim(OutputDir) // 'COVwhtot_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,COVwhtot_hpos)
OPEN(3, FILE = trim(OutputDir) // 'COVchtot_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,COVchtot_hpos)
OPEN(3, FILE = trim(OutputDir) // 'COVhhbar_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,COVhhbar_hpos)

OPEN(3, FILE = trim(OutputDir) // 'COVkw.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,COVkw)
OPEN(3, FILE = trim(OutputDir) // 'COVkw_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,COVkw_hpos)
OPEN(3, FILE = trim(OutputDir) // 'COVkh_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,COVkh_hpos)
OPEN(3, FILE = trim(OutputDir) // 'COVkhtot_hpos.txt', STATUS = 'replace'); CALL WriteMatrix(3,Twork,1,COVkhtot_hpos)

OPEN(3, FILE = trim(OutputDir) // 'PCh.txt', STATUS = 'replace'); CALL WriteMatrix(3,7,Twork,PCh)
OPEN(3, FILE = trim(OutputDir) // 'PCk.txt', STATUS = 'replace'); CALL WriteMatrix(3,7,Twork,PCk)
OPEN(3, FILE = trim(OutputDir) // 'PCc.txt', STATUS = 'replace'); CALL WriteMatrix(3,7,Twork,PCc)
OPEN(3, FILE = trim(OutputDir) // 'PCw.txt', STATUS = 'replace'); CALL WriteMatrix(3,7,Twork,PCw)
OPEN(3, FILE = trim(OutputDir) // 'PCy.txt', STATUS = 'replace'); CALL WriteMatrix(3,7,Twork,PCy)

!PARAMETERS
OPEN(3, FILE = trim(OutputDir) // 'Parameters.txt', STATUS = 'replace')
	write(3,*) 'vareta: ',vareta
	write(3,*) 'varalpha: ',varalpha
	write(3,*) 'rho: ',rho
	write(3,*) 'gam: ',gam
	write(3,*) 'bet: ',bet
	write(3,*) 'R: ',R
	write(3,*) 'Rnet: ',Rnet
	write(3,*) 'borrowlim: ',borrowlim
	write(3,*) 'psi: ',psi
	write(3,*) 'sig: ',sig
	write(3,*) 'Epsi: ',Epsi
	write(3,*) 'Vlogpsi: ',Vlogpsi
	write(3,*) 'Elogpsi: ',Elogpsi
	write(3,*) 'ben: ',ben
	write(3,*) 'chi: ',chi
	write(3,*) 'Vlogzeta: ',Vlogzeta
	write(3,*) 'CVzetapow: ',CVzetapow
	write(3,*) 'Epsipow: ',Epsipow
	write(3,*) 'Elogpsipow: ',Elogpsipow
	write(3,*) 'Vlogpsipow: ',Vlogpsipow
	write(3,*) 'Vpsipow: ',Vpsipow
	write(3,*) 'CVpsipow: ',CVpsipow
	write(3,*) 'chitild: ',chitild
	write(3,*) 'rhopref: ',rhopref
	write(3,*) 'err_w: ',err_w
	write(3,*) 'err_c: ',err_c
	write(3,*) 'err_h: ',err_h
	write(3,*) 'err_y: ',err_y
CLOSE(3)


!SIMULATIONS
IF (SaveSimulations==1) THEN
	OPEN(3, FILE = trim(OutputDir) // 'ksim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Ttot+1,ksim)
	OPEN(3, FILE = trim(OutputDir) // 'ysim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Ttot,ysim)
	OPEN(3, FILE = trim(OutputDir) // 'ynetsim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Ttot,ynetsim)
	OPEN(3, FILE = trim(OutputDir) // 'csim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Ttot,csim)
	OPEN(3, FILE = trim(OutputDir) // 'cgrosim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Ttot,cgrosim)
	OPEN(3, FILE = trim(OutputDir) // 'mucsim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Ttot,mucsim)
	OPEN(3, FILE = trim(OutputDir) // 'esim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Twork,esim)
	OPEN(3, FILE = trim(OutputDir) // 'zsim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Twork,zsim)
	OPEN(3, FILE = trim(OutputDir) // 'wsim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Twork,wsim)
	OPEN(3, FILE = trim(OutputDir) // 'taxsim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Twork,taxsim)
	OPEN(3, FILE = trim(OutputDir) // 'hsim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Twork,hsim)
	OPEN(3, FILE = trim(OutputDir) // 'hbarsim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Twork,hbarsim)
	OPEN(3, FILE = trim(OutputDir) // 'htotsim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Twork,htotsim)
	OPEN(3, FILE = trim(OutputDir) // 'mulsim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Twork,mulsim)
	OPEN(3, FILE = trim(OutputDir) // 'bsim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Twork,bsim)
	OPEN(3, FILE = trim(OutputDir) // 'psim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Tret,psim)
	OPEN(3, FILE = trim(OutputDir) // 'fsim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,Twork,fsim)
	OPEN(3, FILE = trim(OutputDir) // 'fPsimI.txt', STATUS = 'replace'); CALL WriteMatrixCSVInteger(3,1,Twork,fPsimI)
	OPEN(3, FILE = trim(OutputDir) // 'fTsimI.txt', STATUS = 'replace'); CALL WriteMatrixCSVInteger(3,nsim,Twork,fTsimI)
	OPEN(3, FILE = trim(OutputDir) // 'asim.txt', STATUS = 'replace'); CALL WriteMatrixCSV(3,nsim,1,asim)
END IF



END SUBROUTINE SaveOutput